$(document).ready(function() {
  
  $(window).scroll(function() {
    if($(window).scrollTop() > {{ settings.header_top_offset }})
      $('body').addClass('scrolled-down');
    else
      $('body').removeClass('scrolled-down');
  });
  
  $('select').filter(':visible').not('.dont-selectize, .selectize-on-load').each(selectize_selectbox_item);
  
  $('body').on('click', '[data-togglehandleto]', function(e) {
    e.preventDefault();
    var $this = $(this),
        $target = $($this.attr('data-togglehandleto'));
    if($(this).hasClass('expanded')) {
      $this.removeClass('expanded');
      $target.slideUp('slow');
    } else {
      $target.removeClass('hidden').hide().slideDown('slow', function() { $this.addClass('expanded'); });
    }
  });
  
  $('.sorting-tools')
  .on('change', 'select.sort-by', function(e) {
    e.preventDefault();
    var $this = $(this),
        $container = $(this).closest('.sorting-tools'),
        $sort_order = $container.find('.sort-order'),
        sort_by = $this.val();
    if($this.val() == 'title'
    || $this.val() == 'price')
      sort_by += '-'+($sort_order.hasClass('desc') ? 'descending' : 'ascending');
    $('.sorting-tools select.sort-by').not($this).val($this.val());
    window.location = '?sort_by='+sort_by;
  })
  .on('click', '.sort-order', function(e) {
    e.preventDefault();
    var $this = $(this),
        $container = $(this).closest('.sorting-tools'),
        $sort_by = $container.find('select.sort-by'),
        sort_by = $sort_by.val();console.log('this', $this, 'container', $container, 'sort_by', $sort_by, 'sort_by_value', sort_by);
    if($this.hasClass('desc'))
      $('.sorting-tools .sort-order').removeClass('desc').addClass('asc');
    else
      $('.sorting-tools .sort-order').addClass('desc').removeClass('asc');
    if($sort_by.val() == 'title'
    || $sort_by.val() == 'price')
      sort_by += '-'+($this.hasClass('desc') ? 'descending' : 'ascending');
    window.location = '?sort_by='+sort_by;
  })
  .on('click', '.list-style button', function(e) {
    e.preventDefault();
    var $this = $(this),
        style = $this.hasClass('list') ? 'list' : 'grid',
        $items_container = $(this).closest('.sorting-tools').closest('.collection-grid').eq(0);
    $('.sorting-tools .list-style .'+style).addClass('active').siblings('button:not(.'+style+')').removeClass('active');
    if($this.hasClass('list')) {
      $items_container.removeClass('style-grid').addClass('style-list');
      dirsk_set_pref('coll_list_style', 'list');
    } else {
      $items_container.removeClass('style-list').addClass('style-grid');
      dirsk_set_pref('coll_list_style', 'grid');
    }
  });
  var pref_coll_list_style = themedomain_get_pref('coll_list_style');
  if(pref_coll_list_style == 'list') {
    $('.collection-grid').removeClass('style-grid').addClass('style-list');
    $('.list-style button.grid').removeClass('active');
    $('.list-style button.list').addClass('active');
  }
  
  /* ---------------
     Collection page
     --------------- */
  $('body').on('click', '.collection-grid-item .do-add-to-cart[data-variantid]', function(e) {
    e.preventDefault();
    var $this = $(this),
        $grid_item = $this.closest('.collection-grid-item'),
        quantity = 1,
        variant_id = $this.attr('data-variantid');
    if(quantity && variant_id) {
      $this.addClass('loading').prop('disabled', true);
      $.ajax({
        url: '/cart/add.js',
        data: {
          quantity: quantity,
          id: variant_id
        },
        dataType: 'json',
        jsonp: false,
        context: $grid_item,
      })
      .done(function(response, textStatus, jqXHR) {
        $(this).find('.add-to-cart-status').html(
          '<div class="alert alert-success alert-dismissible alert-has-fa" role="alert">'
            +'<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'
            +'<i class="fa fa-check"></i> &nbsp;Added to cart'
          +'</div>'
        );
        update_cart_count_display();
      })
      .fail(function(jqXHR, textStatus, errorThrown) {
        $(this).find('.add-to-cart-status').html(
          '<div class="alert alert-danger alert-dismissible alert-has-fa" role="alert">'
            +'<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'
            +'<i class="fa fa-times"></i> &nbsp;'+jqXHR.responseJSON.message+': '+jqXHR.responseJSON.description
          +'</div>'
        );
      })
      .always(function(data_jqXHR, textStatus, jqXHR_errorThrown) {
        $(this).find('.btn-add-to-cart').removeClass('loading').prop('disabled', false).removeAttr('disabled');
      });
    }
  });
  
  /* --------------------
     Product details page
     -------------------- */
  if(typeof($('.owl-carousel').owlCarousel) != 'undefined') {
    $('.owl-carousel').owlCarousel({
      loop: false,
      margin:10,
      nav: true,
      mouseDrag: false,
      responsive:{
        0:   { items:1 },
        600: { items:3 },
        1000:{ items:5 }
      }
    });
  }
  $('body').on('click', '.product-all-images a[href]', function(e) {
    e.preventDefault();
    var $prod_main_image = $('.product-main-image'),
        img_obj = new Image();
    if($prod_main_image.hasClass('loading')) return;
    $prod_main_image.addClass('loading');
    img_obj.onload = function() {
      $prod_main_image.find('img').attr('src', this.src);
      $prod_main_image.removeClass('loading');
    };
    img_obj.src = $(this).attr('href');
  });
  
  $('input[type="text"].numerify').each(function(i, el) {
    $(el).wrap('<div class="numerified" />');
    $(el).before('<a href="javascript: void(0)" class="dec"></a>');
    $(el).after('<a href="javascript: void(0)" class="inc"></a>');
  });
  
  $('body').on('click', '.numerified .inc, .numerified .dec', function(e) {
    e.preventDefault();
    var $this = $(this),
        $container = $(this).closest('.numerified'),
        $input = $container.find('input'),
        min = (typeof($input.attr('min')) == 'undefined' || isNaN($input.attr('min'))) ? 0 : parseInt($input.attr('min')),
        max = (typeof($input.attr('max')) == 'undefined' || isNaN($input.attr('max'))) ? 20 : parseInt($input.attr('max')),
        val = $input.val();
    val = isNaN(val) ? min : parseInt(val);
    val = $this.hasClass('dec') ? (val - 1) : (val + 1);
    val = (val > max) ? max : val;
    val = (val < min) ? min : val;
    $input.val(val);
  });
  
  $('#product-details .btn-add-to-cart').click(function(e) {
    e.preventDefault();
    var $this = $(this),
        $container = $this.closest('#product-details'),
        $quantity = $container.find('#qty'),
        quantity = isNaN($quantity.val()) || $quantity.val() < 0 ? 0 : parseInt($quantity.val()),
        $variant_id = $container.find('#variant_id');
    if(quantity <= 0) {
      $container.find('.add-to-cart-status').html(
        '<div class="alert alert-danger alert-dismissible alert-has-fa" role="alert">'
          +'<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'
          +'<i class="fa fa-times"></i> &nbsp;Please set the quantity to 1 or more'
        +'</div>'
      );
    } else if($quantity.val() && $variant_id.val()) {
      $this.addClass('loading').prop('disabled', true);
      $.ajax({
        url: '/cart/add.js',
        data: {
          quantity: $quantity.val(),
          id: $variant_id.val()
        },
        dataType: 'json',
        jsonp: false,
        context: $container,
      })
      .done(function(response, textStatus, jqXHR) {
        $(this).find('.add-to-cart-status').html(
          '<div class="alert alert-success alert-dismissible alert-has-fa" role="alert">'
            +'<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'
            +'<i class="fa fa-check"></i> &nbsp;Added to cart'
          +'</div>'
        );
        update_cart_count_display();
      })
      .fail(function(jqXHR, textStatus, errorThrown) {
        $(this).find('.add-to-cart-status').html(
          '<div class="alert alert-danger alert-dismissible alert-has-fa" role="alert">'
            +'<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'
            +'<i class="fa fa-times"></i> &nbsp;'+jqXHR.responseJSON.message+': '+jqXHR.responseJSON.description
          +'</div>'
        );
      })
      .always(function(data_jqXHR, textStatus, jqXHR_errorThrown) {
        $(this).find('.btn-add-to-cart').removeClass('loading').prop('disabled', false).removeAttr('disabled');
      });
    }
  });
  
  /* ---------
     Cart page
     --------- */
  if($('ul.empty-cart-browse-by-category').length > 0) {
    $('ul.nav.main-nav > li.has-sub-menu > a').each(function(i, el) {
      $(el).clone().addClass('btn btn-default').wrap('<li />').parent().appendTo('ul.empty-cart-browse-by-category');
    });
  }
  
  if($('body').hasClass('template-cart')) {
    if(typeof(Shopify.Cart) == 'undefined'
    || typeof(Shopify.Cart.ShippingCalculator) == 'undefined') {
      $('#shipping-calculator').hide();
      console.log('Shipping calculator is not available.');
    } else {
      Shopify.Cart.ShippingCalculator.show({
        submitButton: theme.strings.shippingCalcSubmitButton,
        submitButtonDisabled: theme.strings.shippingCalcSubmitButtonDisabled,
        customerIsLoggedIn: theme.strings.shippingCalcCustomerIsLoggedIn,
        moneyFormat: theme.strings.shippingCalcMoneyFormat                                     
      });
    }
  }
  
  $('#shipping-calculator #address_zip').keypress(function (e) {
    var key = e.which;
    if(key == 13) { /* the enter key code */
      e.preventDefault();
      $('#shipping-calculator .get-rates').click();
      return false;
    }
  });
  
}); /* $(document).ready */

$(window).load(function() {
  
  $('select.selectize-on-load').each(selectize_selectbox_item);

}); /* $(window).load */

function handle_product_option_change(value) {
  var option_set_string = new Array();
  for(var x = 1; x <= 3; x++) {
    option_set_string.push($('#product-details .product-option select.product-option-selector[data-index="'+x+'"] option:selected').val());
  } console.log('#product-details select#variant_id option[data-optionset="'+option_set_string.join(':')+'"]');
  $('#product-details select#variant_id').val($('#product-details select#variant_id option[data-optionset="'+option_set_string.join(':')+'"]').attr('value'));
}

function update_cart_count_display() {
  $.getJSON(
    '/cart.js',
    {},
    function(response) {
      $('#btn-cart .count').attr('data-itemcount', response.item_count).html(response.item_count);
    }
  );
}

function selectize_selectbox_item(i, select) {
  var selectize_options = {
    create: false
  };
  if(!$(select).hasClass('dont-sort')) {
    selectize_options.sortField = {
      field: 'text',
      direction: 'asc'
    }
  }
  if(typeof($(select).attr('data-onchange')) != 'undefined') {
    selectize_options.onChange = function(value) { if(typeof(window[$(select).data('onchange')]) == 'function') { window[$(select).data('onchange')](value); } };
    $(select).data('onchange', $(select).attr('data-onchange')).removeAttr('data-onchange');
  }
  $(select).selectize(selectize_options);
}

function themedomain_get_pref(pref) {
  var prefs = themedomain_get_prefs(),
      pref;
  pref = (typeof(prefs[pref]) == 'undefined') ? '' : prefs[pref];
  return pref;
}

function dirsk_set_pref(pref, pref_value) {
  var prefs = themedomain_get_prefs();
  prefs[pref] = pref_value;
  if(typeof(Cookies) != 'undefined') {
    Cookies.set('_uprefs', prefs);
  }
}

function themedomain_get_prefs() {
  if(typeof(Cookies) == 'undefined') return {};
  var prefs = Cookies.getJSON('_uprefs');
  prefs = (typeof(prefs) == 'undefined' || prefs == null || prefs == '') ? {} : prefs;
  return prefs;
}

var delay_func = (function(){
  var timer = 0;
  return function(callback, ms){
    clearTimeout (timer);
    timer = setTimeout(callback, ms);
  };
})();